﻿using OpenTK.Mathematics;
using OpenTK.Windowing.Common;

namespace GraphicsManager.Interfaces;

public interface IParent
{
	public Vector2 LocationAsFloat { get; }
	public IParent? Parent { get; }
	public Vector2i Size { get; }
	public void ParentResize(ResizeEventArgs e);
	public float[] RctToFloat(int x, int y, int Width, int Height, bool hastexture = false, float z = 0.0f);
	public Vector3 PointToVector(float x, float y, float z = 0.0f);
	public float IntToFloat(float p, bool Invert = false);
	public void TryDraw();
	public void ReportSizeUpdate(IRenderObject Control);
	public float FloatToInt(float p, bool Invert = false);
	public Vector2i Position { get; }
}
